/* tslint:disable */
/**
 * This file was automatically generated by json-schema-to-typescript.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
 * and run json-schema-to-typescript to regenerate this file.
 */

/**
 * Lerna is a tool used in JavaScript monorepo projects. The lerna.json file is
 * used to configure lerna to to best fit your project.
 */
export interface AJSONSchemaForLernaJsonFiles {
  /**
   * The current version of the repository (or independent).
   */
  version?: string;
  /**
   * Specify which client to run commands with (change to "yarn" to run commands with yarn. Defaults to "npm".
   */
  npmClient?: string;
  /**
   * Array of strings that will be passed as arguments to the npmClient.
   */
  npmClientArgs?: string[];
  /**
   * Enable workspaces integration when using Yarn.
   */
  useWorkspaces?: boolean;
  /**
   * Array of globs to use a workspace locations.
   */
  workspaces?: string[];
  /**
   * Array of globs to use a package locations.
   */
  packages?: string[];
  /**
   * Array of globs of files to ignore when detecting changed packages.
   */
  ignoreChanges?: string[];
  /**
   * Options for the CLI commands.
   */
  command?: {
    /**
     * Options for the publish command.
     */
    publish?: {
      /**
       * An array of globs that won't be included in "lerna changed/publish". Use this to prevent publishing of a new version unnecessarily for changes, such as fixing a README.md typo.
       */
      ignoreChanges?: string | string[];
      /**
       * A custom commit message when performing version updates for publication. See https://github.com/lerna/lerna/tree/master/commands/version#--message-msg for more information.
       */
      message?: string;
      [k: string]: unknown;
    };
    /**
     * Options for the bootstrap command.
     */
    bootstrap?: {
      /**
       * An array of globs that won't be bootstrapped when running "lerna bootstrap" command.
       */
      ignore?: string | string[];
      /**
       * Array of strings that will be passed as arguments directly to "npm install" during the "lerna bootstrap" command.
       */
      npmClientArgs?: string[];
      [k: string]: unknown;
    };
    /**
     * Options for the init command.
     */
    init?: {
      /**
       * Use lerna 1.x behavior of "exact" comparison. It will enforce the exact match for all subsequent executions.
       */
      exact?: boolean;
      [k: string]: unknown;
    };
    /**
     * Options for the run command.
     */
    run?: {
      /**
       * Which npm client should be used when running package scripts.
       */
      npmClient?: string;
      [k: string]: unknown;
    };
    /**
     * Options for the version command.
     */
    version?: {
      /**
       * A whitelist of globs that match git branches where "lerna version" is enabled.
       */
      allowBranch?: string | string[];
      /**
       * A custom commit message when performing version updates for publication. See https://github.com/lerna/lerna/tree/master/commands/version#--message-msg for more information.
       */
      message?: string;
      [k: string]: unknown;
    };
  };
  [k: string]: unknown;
}
